module ActiveRedis
  module DirtyObjects
    class SortedSet < ActiveRedis::DirtyObjects::Array
      attr_accessor :hash
      attr_reader :original

      def []=(score, value)
        self.push(score)
        @hash ||= {}
        @hash[value] = score
      end

      def replace(hash)
        @hash = hash
        self.clear
        hash.values.each do |value|
          self.push(value)
        end
        hash
      end

      def changes
        super.merge(hash: @hash)
      end
    end
  end
end